package guru.kake.ronove

class Dictionary {
    val words: MutableList<Word> = mutableListOf()
    private var rootWord: Word? = null

    fun createIndex() {
        for (i in words.indices) {
            words[i].id=i
        }
    }

    fun createBST() {
        rootWord = words[words.size/2]
        createBST(words, rootWord!!)
    }

    private fun createBST(children: List<Word>, parent: Word) {
        val left = children.subList(0, children.size / 2)
        val right = children.subList(children.size / 2 + 1, children.size)

        if (left.isNotEmpty()) {
            parent.left = left[left.size / 2]
            createBST(left, left[left.size / 2])
        }
        if (right.isNotEmpty()) {
            parent.right = right[right.size / 2]
            createBST(right, right[right.size / 2])
        }
    }

    fun findBST(id: Int): Word? {
        var node = rootWord
        while (true) {
            if (node!=null) {
                if (node.id < id) {
                    node = node.right
                    continue
                }
                else if (node.id > id) {
                    node = node.left
                    continue
                }
            }
            return node
        }
    }
}

class Word {
    var left: Word? = null
    var right: Word? = null
    var id: Int = -1
}